local array = function(n,v)
	local m ={}
	for i=1,n do m[i] = v end
	return m
end

ticks = array(32,0)
px = array(32,0)
py = array(32,0)
antispeed = {}

NORMAL_TOLERANCE = 1.2
LAGGER_TOLERANCE = 1.3

addhook("join","antispeed.join")
function antispeed.join(id)
	px[id],py[id] = player(id,"x"),player(id,"y")
end

addhook("spawn","antispeed.spawn")
function antispeed.spawn(id)
	px[id],py[id] = player(id,"x"),player(id,"y")
end

addhook("startround","antispeed.startround")
function antispeed.startround()
	for _,id in ipairs(player(0,"table")) do
		px[id],py[id] = player(id,"x"),player(id,"y")
	end
end

count = 0
addhook("second","antispeed.second")
function antispeed.second()
	
	for _,id in ipairs(player(0,'table')) do
		
		if player(id,"health") > 0 then
			local man_dist = math.floor(math.sqrt((player(id,"x") - px[id])^2 + (player(id,"y")-py[id])^2) + 0.5)
		
			if player(id,"ping") < 200 then
				tolerance  = NORMAL_TOLERANCE
			else
				tolerance = LAGGER_TOLERANCE
			end
			
			if( man_dist > tolerance * (170 + math.floor(player(id,"speedmod") * 6.1))) then
				msg("speedhack "..player(id,"name"))
				--remove dashes below to kick..
				--parse("kick "..id)
			end
			
			px[id] = player(id,"x");
			py[id] = player(id,"y")
		end
		
		
	end
	
end

addhook("movetile","antispeed.movetile")
function antispeed.movetile(id,x,y)
	if entity(x,y,"typename")=="Func_Teleport" then
		px[id],py[id] = entity(x,y,"int0")*32 + 16, entity(x,y,"int1") * 32 + 16
	end
end

function split(str, pat)
   local t = {} 
   local fpat = "(.-)" .. pat
   local last_end = 1
   local s, e, cap = str:find(fpat, 1)
   while s do
      if s ~= 1 or cap ~= "" then
	 table.insert(t,cap)
      end
      last_end = e+1
      s, e, cap = str:find(fpat, last_end)
   end
   if last_end <= #str then
      cap = str:sub(last_end)
      table.insert(t, cap)
   end
   return t
end

addhook("parse","antispeed.parse")
function antispeed.parse(text)
	local t = split(text," ")
	if #t == 4 then
		if t[1] == "setpos" then
			local id,x,y = tonumber(t[2]),tonumber(t[3]),tonumber(t[4])
			px[id] = x; py[id] = y			
		end
	end	
end